unit rDBGridSorter_ADONis;

{<
  rDBGridSorter_ADONis unit contains TrDBGridSorter_ADONis - sorter for TWCustomADODataSet
  used by rDBGrid to sort ADONis datasets.

  @author(Rosinsky Software - <http://www.rosinsky.cz/delphi>)
  @created(Mar 2020)
  @lastmod(Mar 2020)
}

interface

uses
  Windows, Messages, SysUtils, Graphics, Classes, Controls, Menus, Dialogs,
  StdCtrls, Forms, DB, Variants, rDBGrid,
  AdoDS;

type
  { sorter for TWCustomADODataSet used by rDBGrid to sort ADONis datasets }
  TrDBGridSorter_ADONis = class(TrDBGridCustomSorter)
  protected
    function SetSort_CreateIndex(DataSet: TDataSet; const SortString: string; const SortFields: string; const DescendingFields: string): boolean; override;
  end;

procedure Register; {< @exclude }

implementation

{$R *.res}
uses RosiCompGlobalCfg;

type
  THackWCustomADODataSet = class(TWCustomADODataSet)
  end;

procedure Register;
begin
  RegisterComponents('Rosi DB', [TrDBGridSorter_ADONis]);
end;

function TrDBGridSorter_ADONis.SetSort_CreateIndex(DataSet: TDataSet; const SortString: string; const SortFields: string; const DescendingFields: string): boolean;
var
  DS: TWCustomADODataSet;
begin
  if (DataSet is TWCustomADODataSet) then
  begin
    DS:=DataSet as TWCustomADODataSet;
    THackWCustomADODataSet(DS).Sort:=SortString;
    Result:=true;
  end
  else
    Result:= inherited;
end;

end.
