unit rDBGrid_DTEdit;

{<
  rDBGrid_DTEdit is design time dialog used by rDBGrid component.

  Updated version compatible with Delphi2010+.
  Full functional demo.
  @author(Rosinsky Software - <http://www.rosinsky.cz/delphi>)
  @created(May 2006)
  @lastmod(Jan 2022)
}

interface

{$INCLUDE _delphi_ver.inc}

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Buttons, DBGrids, rDBGrid, db, CheckLst, ComCtrls,
{$IFDEF DXE2P} UITypes, Types, {$ENDIF}
  ExtCtrls, IniFiles, rImprovedComps, PropSaveMain, Grids, rHTMLLabel;

type
  { design time dialog used by rDBGrid component }
  TrDBGrid_DTEditForm = class(TForm)
    pc: TPageControl;
    tsCol: TTabSheet;
    tsTag: TTabSheet;
    gbActions: TGroupBox;
    gbEdit: TGroupBox;
    chAdd: TCheckBox;
    chEdit: TCheckBox;
    chDuplic: TCheckBox;
    chDelete: TCheckBox;
    chSaveAdd: TCheckBox;
    chAutoEdit: TCheckBox;
    chEditGroup: TCheckBox;
    gbTools: TGroupBox;
    chSort: TCheckBox;
    chFilter: TCheckBox;
    chColumn: TCheckBox;
    chClose: TCheckBox;
    chEnaAll: TCheckBox;
    tsLink: TTabSheet;
    Label10: TrHTMLLabel;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    chProps: TCheckBox;
    PSFile: TPropSaveFile;
    PSMain: TPropSaveMain;
    gbEmpty: TrGroupBox;
    btClose: TButton;
    gbLeft1: TrGroupBox;
    Label1: TrHTMLLabel;
    lbFields: TrListBox;
    btMove: TButton;
    btMoveAll: TButton;
    Label3: TrHTMLLabel;
    eSep: TEdit;
    gbRight1: TrGroupBox;
    Label2: TrHTMLLabel;
    lbCol: TrCheckListBox;
    btUp: TButton;
    btDown: TButton;
    btDel: TButton;
    btDelAll: TButton;
    btDelNoField: TButton;
    gbColBottom: TrGroupBox;
    lFld: TrHTMLLabel;
    lTitle: TrHTMLLabel;
    eTitle: TEdit;
    chReadOnly: TCheckBox;
    btNext: TButton;
    lblFName: TrHTMLLabel;
    gbLeft2: TrGroupBox;
    gbRight2: TrGroupBox;
    lblLink: TrHTMLLabel;
    lbLink: TrCheckListBox;
    lblLinkType: TrHTMLLabel;
    cbLinkType: TrComboBoxEx;
    lblLinkInfo: TrHTMLLabel;
    lblBool: TrHTMLLabel;
    lbBool: TrCheckListBox;
    lblBoolVal: TrHTMLLabel;
    lblBoolInfo: TrHTMLLabel;
    eBoolVal: TEdit;
    gbLeft3: TrGroupBox;
    gbRight3: TrGroupBox;
    Label11: TrHTMLLabel;
    lbPick: TrCheckListBox;
    Label24: TrHTMLLabel;
    lbColor: TrCheckListBox;
    gbLeft4: TrGroupBox;
    gbRight4: TrGroupBox;
    Label13: TrHTMLLabel;
    lbTitleImg: TrCheckListBox;
    Label17: TrHTMLLabel;
    Label18: TrHTMLLabel;
    cbDataImg: TrComboBoxEx;
    lbDataImg: TrListBox;
    btDAdd: TButton;
    btDDel: TButton;
    rGroupBox2: TrGroupBox;
    Label14: TrHTMLLabel;
    eTitleImg: TrEditNum;
    UpDownTitleImg: TUpDown;
    TitleImg: TImage;
    grDataImgBottom: TrGroupBox;
    DataImg: TImage;
    lDataImgVal: TrHTMLLabel;
    lDataImgIdx: TrHTMLLabel;
    lblDataImgHint: TrHTMLLabel;
    lDataImgText: TrHTMLLabel;
    eDataImgVal: TEdit;
    eDataImgIdx: TrEditNum;
    UpDownDataImg: TUpDown;
    eDataImgText: TEdit;
    Label4: TrHTMLLabel;
    TabSheet3: TTabSheet;
    lbDrawPick: TrCheckListBox;
    Label5: TrHTMLLabel;
    rHTMLLabel1: TrHTMLLabel;
    gbLeft5: TrGroupBox;
    lblDate: TrHTMLLabel;
    lbDate: TrCheckListBox;
    gbRight5: TrGroupBox;
    Label16: TrHTMLLabel;
    TabSheet4: TTabSheet;
    gbRight6: TrGroupBox;
    Label25: TrHTMLLabel;
    lbHints: TrCheckListBox;
    gbLeft6: TrGroupBox;
    Label28: TrHTMLLabel;
    lbFilterFields: TrCheckListBox;
    btCollapse: TButton;
    btExpand: TButton;
    tsGroup: TTabSheet;
    gbLeftGroups: TrGroupBox;
    Label29: TrHTMLLabel;
    lbGroups: TrListBox;
    btNewGroup: TButton;
    btDelGroup: TButton;
    gbGroupBottom: TrGroupBox;
    Label31: TrHTMLLabel;
    eGroupCollapsedTitle: TEdit;
    cgGroupTitleColor: TrColorBox;
    Label32: TrHTMLLabel;
    gbRightGroups: TrGroupBox;
    Label33: TrHTMLLabel;
    lbGroupFields: TrCheckListBox;
    btGroupUpdate: TButton;
    rGroupBox1: TrGroupBox;
    Label34: TrHTMLLabel;
    cbGroupMaster: TrComboBoxEx;
    btGroupUpdateAll: TButton;
    Label35: TrHTMLLabel;
    cgGroupLineColor: TrColorBox;
    btNone1: TrURLLabel;
    btNone2: TrURLLabel;
    btGroupCollapse: TButton;
    btGroupExpand: TButton;
    Label36: TrHTMLLabel;
    eGroupMasterMask: TEdit;
    lblInfo1: TrHTMLLabel;
    lblInfo2: TrHTMLLabel;
    chGroupLock: TCheckBox;
    lblInfoSep: TrHTMLLabel;
    TabSheet5: TTabSheet;
    gbLeft7: TrGroupBox;
    Label37: TrHTMLLabel;
    Label38: TrHTMLLabel;
    lbFooterFields: TrCheckListBox;
    gbFooterRight: TrGroupBox;
    Label39: TrHTMLLabel;
    Label40: TrHTMLLabel;
    Label41: TrHTMLLabel;
    cbColor: TrColorBox;
    gbFontStyle: TGroupBox;
    chNormal: TCheckBox;
    chBold: TCheckBox;
    chItalic: TCheckBox;
    chUnderline: TCheckBox;
    eFontSize: TrEditNum;
    Label42: TrHTMLLabel;
    eFooterMask: TEdit;
    Label43: TrHTMLLabel;
    cbFooterTags: TrComboBoxEx;
    btAddFooterTag: TButton;
    chFooterOn: TCheckBox;
    gbAlignment: TRadioGroup;
    tsBars: TTabSheet;
    gbLeft8: TrGroupBox;
    rHTMLLabel3: TrHTMLLabel;
    lbDataBar: TrCheckListBox;
    rGroupBox5: TrGroupBox;
    rHTMLLabel6: TrHTMLLabel;
    lbStatusBar: TrCheckListBox;
    gbDataBarParams: TrGroupBox;
    lblDataBarLimits: TrHTMLLabel;
    eDatabarMin: TrEditNum;
    eDatabarMax: TrEditNum;
    lblDatabarColor: TrHTMLLabel;
    cbDatabarColorFrom: TrColorBox;
    gbDatabarDemo: TrGroupBox;
    cbDatabarColorTo: TrColorBox;
    gbStatusBarParams: TrGroupBox;
    lblStatusMax: TrHTMLLabel;
    eStatusSteps: TrEditNum;
    lblStatusColor: TrHTMLLabel;
    cbStatusColorAll: TrColorBox;
    cbDataBarText: TComboBox;
    rHTMLLabel4: TrHTMLLabel;
    rHTMLLabel5: TrHTMLLabel;
    cbStatusColorDone: TrColorBox;
    rHTMLLabel7: TrHTMLLabel;
    cbStatusType: TComboBox;
    lblFontReset: TrHTMLLabel;
    lblFontInfo: TrHTMLLabel;
    lblFontSet: TrHTMLLabel;
    FontDlg: TFontDialog;
    lblAlign: TrHTMLLabel;
    lbTime: TrCheckListBox;
    lblTime: TrHTMLLabel;
    gbTimeStep: TrGroupBox;
    lblStep: TrHTMLLabel;
    eTimeStep: TrEditNum;
    TabSheet6: TTabSheet;
    gbLeft9: TrGroupBox;
    rHTMLLabel8: TrHTMLLabel;
    lbFixedWidth: TrCheckListBox;
    btFixedWidth: TrURLLabel;
    lblGraphics: TrHTMLLabel;
    lbGraphics: TrCheckListBox;
    lblGraphicsInfo: TrHTMLLabel;
    lblRichText: TrHTMLLabel;
    lbRichText: TrCheckListBox;
    btGroupAddMask: TrHTMLLabel;
    rGroupBox4: TrGroupBox;
    chGrouppingOn: TCheckBox;
    chMergedCell: TCheckBox;
    chCanExpand: TCheckBox;
    gbTitleBtnOpt: TrGroupBox;
    gbTitleFilterOpt: TrGroupBox;
    chFilterFunnelBtn: TCheckBox;
    chFilterTextBar: TCheckBox;
    rHTMLLabel2: TrHTMLLabel;
    rHTMLLabel9: TrHTMLLabel;
    lbTitleButtons: TrCheckListBox;
    eTitleButtons: TEdit;
    rHTMLLabel10: TrHTMLLabel;
    gbTitleBtnImages: TrGroupBox;
    Image1: TImage;
    Image2: TImage;
    Image3: TImage;
    gbTitleHintOpt: TrGroupBox;
    Label26: TrHTMLLabel;
    eHint: TEdit;
    rHTMLLabel11: TrHTMLLabel;
    eMergedCellHint: TEdit;
    Label27: TrHTMLLabel;
    chFilterPanel: TCheckBox;
    lblHTMLText: TrHTMLLabel;
    lbHTMLText: TrCheckListBox;
    rHTMLLabel15: TrHTMLLabel;
    rHTMLLabel18: TrHTMLLabel;
    rHTMLLabel12: TrHTMLLabel;
    eTitleBtn1Hint: TEdit;
    rHTMLLabel13: TrHTMLLabel;
    eTitleBtn2Hint: TEdit;
    rHTMLLabel14: TrHTMLLabel;
    eTitleBtn3Hint: TEdit;
    gbFilterPanel: TrGroupBox;
    rHTMLLabel17: TrHTMLLabel;
    rHTMLLabel16: TrHTMLLabel;
    eFilterPanelButtons: TEdit;
    gbFilterPanelBtnImages: TrGroupBox;
    Image4: TImage;
    Image5: TImage;
    Image11: TImage;
    rHTMLLabel19: TrHTMLLabel;
    rHTMLLabel20: TrHTMLLabel;
    eFilterPanelBtn1Hint: TEdit;
    rHTMLLabel21: TrHTMLLabel;
    eFilterPanelBtn2Hint: TEdit;
    rHTMLLabel22: TrHTMLLabel;
    eFilterPanelBtn3Hint: TEdit;
    rHTMLLabel23: TrHTMLLabel;
    eGroupMergedCellTitle: TEdit;
    lbDataImgAlign: TrHTMLLabel;
    cbDataImgAlign: TrComboBoxEx;
    lbDataImgAlignHint: TrHTMLLabel;
    procedure chEditGroupClick(Sender: TObject);
    procedure chEnaAllClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure lbColDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure btUpClick(Sender: TObject);
    procedure btDownClick(Sender: TObject);
    procedure lbColClickCheck(Sender: TObject);
    procedure lbColKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure btDelClick(Sender: TObject);
    procedure btDelAllClick(Sender: TObject);
    procedure btCloseClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure btMoveClick(Sender: TObject);
    procedure btMoveAllClick(Sender: TObject);
    procedure lbColClick(Sender: TObject);
    procedure eTitleChange(Sender: TObject);
    procedure eTitleEnter(Sender: TObject);
    procedure eTitleExit(Sender: TObject);
    procedure btNextClick(Sender: TObject);
    procedure lbBoolClick(Sender: TObject);
    procedure lbBoolClickCheck(Sender: TObject);
    procedure eBoolValExit(Sender: TObject);
    procedure btDelNoFieldClick(Sender: TObject);
    procedure lbLinkClickCheck(Sender: TObject);
    procedure lbLinkClick(Sender: TObject);
    procedure lbTitleImgClickCheck(Sender: TObject);
    procedure lbTitleImgClick(Sender: TObject);
    procedure eTitleImgExit(Sender: TObject);
    procedure cbLinkTypeExit(Sender: TObject);
    procedure eTitleImgChange(Sender: TObject);
    procedure cbDataImgChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure lbDataImgClick(Sender: TObject);
    procedure eDataImgValExit(Sender: TObject);
    procedure btDDelClick(Sender: TObject);
    procedure btDAddClick(Sender: TObject);
    procedure eDataImgIdxChange(Sender: TObject);
    procedure cbDataImgDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure UpDownTitleImgChangingEx(Sender: TObject; var AllowChange: Boolean; NewValue: Smallint; Direction: TUpDownDirection);
    procedure UpDownDataImgChangingEx(Sender: TObject; var AllowChange: Boolean; NewValue: Smallint; Direction: TUpDownDirection);
    procedure chReadOnlyClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure lbPickClickCheck(Sender: TObject);
    procedure lbDrawPickClickCheck(Sender: TObject);
    procedure lbHintsClick(Sender: TObject);
    procedure lbHintsClickCheck(Sender: TObject);
    procedure eHintExit(Sender: TObject);
    procedure btCollapseClick(Sender: TObject);
    procedure lbGroupsClick(Sender: TObject);
    procedure btGroupUpdateClick(Sender: TObject);
    procedure btNewGroupClick(Sender: TObject);
    procedure btDelGroupClick(Sender: TObject);
    procedure lbGroupFieldsClickCheck(Sender: TObject);
    procedure btGroupUpdateAllClick(Sender: TObject);
    procedure pcChange(Sender: TObject);
    procedure lbColDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
    procedure eGroupCollapsedTitleEnter(Sender: TObject);
    procedure eGroupCollapsedTitleExit(Sender: TObject);
    procedure btGroupCollapseClick(Sender: TObject);
    procedure btGroupAddMaskAnchorClick(Sender: TObject; LinkName: string);
    procedure lbFooterFieldsClick(Sender: TObject);
    procedure lbFooterFieldsClickCheck(Sender: TObject);
    procedure btAddFooterTagClick(Sender: TObject);
    procedure chNormalClick(Sender: TObject);
    procedure lbDataImgDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
    procedure lbDataImgKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
    procedure chFilterFunnelBtnClick(Sender: TObject);
    procedure chFilterTextBarClick(Sender: TObject);
    procedure chGrouppingOnClick(Sender: TObject);
    procedure chFooterOnClick(Sender: TObject);
    procedure lbDataBarClick(Sender: TObject);
    procedure lbDataBarClickCheck(Sender: TObject);
    procedure eDatabarMinExit(Sender: TObject);
    procedure lbStatusBarClick(Sender: TObject);
    procedure lbStatusBarClickCheck(Sender: TObject);
    procedure eStatusStepsExit(Sender: TObject);
    procedure lblFontResetAnchorClick(Sender: TObject; LinkName: string);
    procedure gbRight1RefreshAutoPosition(Sender: TObject);
    procedure lblFontSetAnchorClick(Sender: TObject; LinkName: string);
    procedure lblAlignAnchorClick(Sender: TObject; LinkName: string);
    procedure lbTimeClickCheck(Sender: TObject);
    procedure lbTimeClick(Sender: TObject);
    procedure eTimeStepExit(Sender: TObject);
    procedure btFixedWidthClick(Sender: TObject);
    procedure chMergedCellClick(Sender: TObject);
    procedure chCanExpandClick(Sender: TObject);
    procedure lbTitleButtonsClick(Sender: TObject);
    procedure lbTitleButtonsClickCheck(Sender: TObject);
    procedure eTitleButtonsExit(Sender: TObject);
    procedure eTitleButtonsChange(Sender: TObject);
    procedure eMergedCellHintExit(Sender: TObject);
    procedure eTitleBtn1HintExit(Sender: TObject);
    procedure eTitleBtn2HintExit(Sender: TObject);
    procedure eTitleBtn3HintExit(Sender: TObject);
    procedure chFilterPanelClick(Sender: TObject);
    procedure eFilterPanelButtonsChange(Sender: TObject);
    procedure eFilterPanelButtonsExit(Sender: TObject);
    procedure eFilterPanelBtn1HintExit(Sender: TObject);
    procedure eFilterPanelBtn2HintExit(Sender: TObject);
    procedure eFilterPanelBtn3HintExit(Sender: TObject);
    procedure cbDataImgAlignChange(Sender: TObject);
    procedure lbGraphicsClickCheck(Sender: TObject);
    procedure lbFilterFieldsClickCheck(Sender: TObject);
  private
    Gr: TrDBGrid;
    Tag: Integer;
    Cs: TDBGridColumns;
    Flds: TFields;
    FAsPick: TStrings;
    FAsColor: TStrings;
    FAsDate: TStrings;
    FAsTime: TStrings;
    FAsHTMLText: TStrings;
    FAsRichText: TStrings;
    FAsGraphics: TStrings;
    FAsFixedWidth: TStrings;
    FDrawDropDown: TStrings;
    FTitleButtons: TStrings;
    FTitleHints: TStrings;
    FFilterBtn: TStrings;
    FOptionsEx2: TOptionsEx2;
    isFooterUpdating: Boolean;
    procedure AssignCheckItems(LB: TrCheckListBox; L: TStrings);
    procedure CheckItems(LB: TrCheckListBox; L: TStrings);
    procedure SetCheckedItems(LB: TrCheckListBox; L: TStrings);
    procedure LoadProps;
    procedure SetProps;
    procedure LoadCol(KeepSelected: Boolean);
    procedure AddCol(Fld: TField);
    procedure MoveICheckBox(List: TCheckListBox; old, new: Integer);
    procedure MoveIListBox(List: TListBox; old, new: Integer);
    procedure CheckI(act: Integer);
    procedure RefSelCol;
    procedure SetIniSection;
    procedure LoadDrawPick;
    procedure StoreDrawPick;
    procedure LoadGroups(KeepSelected: Boolean);
    procedure LoadGroupFields(FieldList: TStrings);
    function GetSelGroupName: string;
    procedure UpdateFooterSetting;
    procedure RefDatabarDemo;
  public
  end;

  { initialize and show design time dialog }
function ShowrDBGridEditor(Component: TComponent): Boolean;

implementation

{$R *.dfm}

uses TypInfo, RosiCompGlobalCfg, rtool, rdlg, rpictool;

const
  cTag = 'Tag';

function ShowrDBGridEditor(Component: TComponent): Boolean;
var
  F: TrDBGrid_DTEditForm;
  DS: TDataSource;
begin
  Result:=true;
  F:=TrDBGrid_DTEditForm.Create(Application);
  try
    F.Caption:=Component.Name;
    F.Gr:=(Component as TrDBGrid);
    F.Tag:=GetOrdProp(Component, cTag);
    F.Cs:=GetObjectProp(Component, 'Columns') as TDBGridColumns;
    F.FAsPick:=GetObjectProp(Component, 'FieldsAutoPickList') as TStrings;
    F.FAsColor:=GetObjectProp(Component, 'FieldsAsColor') as TStrings;
    F.FAsDate:=GetObjectProp(Component, 'FieldsAsDate') as TStrings;
    F.FAsTime:=GetObjectProp(Component, 'FieldsAsTime') as TStrings;
    F.FAsHTMLText:=GetObjectProp(Component, 'FieldsAsHTMLText') as TStrings;
    F.FAsRichText:=GetObjectProp(Component, 'FieldsAsRichText') as TStrings;
    F.FAsGraphics:=GetObjectProp(Component, 'FieldsAsGraphics') as TStrings;
    F.FDrawDropDown:=GetObjectProp(Component, 'FieldsDrawDropDown') as TStrings;
    F.FTitleButtons:=GetObjectProp(Component, 'TitleButtons') as TStrings;
    F.FTitleHints:=GetObjectProp(Component, 'TitleHints') as TStrings;
    F.FFilterBtn:=GetObjectProp(Component, 'FieldsFilterButton') as TStrings;
    F.FAsFixedWidth:=GetObjectProp(Component, 'FieldsFixedColumnWidth') as TStrings;
    F.FOptionsEx2:=GetObjectProp(Component, 'OptionsEx2') as TOptionsEx2;
    F.Flds:=nil;
    try
      DS:=GetObjectProp(Component, 'DataSource') as TDataSource;
      if Assigned(DS) and Assigned(DS.DataSet) then
        F.Flds:=DS.DataSet.Fields;
    except
    end;
    F.ShowModal;
    SetOrdProp(Component, cTag, F.Tag);
    F.Gr.FixedGroupedCol(false);
  finally
    FreeAndNil(F);
  end;
  with (Component as TControl) do
    Invalidate;
end;

procedure TrDBGrid_DTEditForm.FormCreate(Sender: TObject);
begin
  PSFile.LoadFile(GetRosiCompIniFile);
  gbDataBarParams.Enabled:=false;
  gbStatusBarParams.Enabled:=false;
  cbFooterTags.Items.Clear;
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_Sum);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_Min);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_Max);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_AVG);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_CountVal);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_CountNull);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_CountAll);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_SelSum);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_SelMin);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_SelMax);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_SelAVG);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_SelCountVal);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_SelCountNull);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_SelCountAll);
  cbFooterTags.Items.Add(cSummaryTag_Prefix + cSummaryTag_RecNo);
end;

procedure TrDBGrid_DTEditForm.FormDestroy(Sender: TObject);
begin ;
end;

procedure TrDBGrid_DTEditForm.FormResize(Sender: TObject);
begin
  gbLeft1.Width:=pc.ClientWidth div 2;
  gbLeft2.Width:=pc.ClientWidth * 2 div 3;
  gbLeft3.Width:=pc.ClientWidth div 2;
  gbLeft4.Width:=pc.ClientWidth div 2;
  gbLeft5.Width:=pc.ClientWidth * 2 div 4;
  gbLeft6.Width:=pc.ClientWidth * 2 div 3;
  gbLeft7.Width:=pc.ClientWidth div 2;
  gbLeft8.Width:=pc.ClientWidth div 2;
  gbLeft9.Width:=pc.ClientWidth div 2;
  gbLeftGroups.Width:=pc.ClientWidth div 2 + 18;
end;

procedure TrDBGrid_DTEditForm.FormShow(Sender: TObject);
begin
  // pc.ActivePageIndex:=0;
  LoadProps;
end;

procedure TrDBGrid_DTEditForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  SetProps;
end;

procedure TrDBGrid_DTEditForm.btCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TrDBGrid_DTEditForm.AssignCheckItems(LB: TrCheckListBox; L: TStrings);
begin
  LB.Items.Assign(lbFields.Items);
  CheckItems(LB, L);
end;

procedure TrDBGrid_DTEditForm.CheckItems(LB: TrCheckListBox; L: TStrings);
var
  i, p: Integer;
  s: string;
begin
  for i:=0 to L.Count - 1 do
  begin
    s:=L.Names[i];
    if s = '' then
      s:=L[i];
    p:=LB.Items.IndexOf(s);
    if p >= 0 then
      LB.Checked[p]:=true;
  end;
end;

procedure TrDBGrid_DTEditForm.LoadProps;
var
  i, p, idx: Integer;
begin
  // set actions controls
  chEnaAll.Checked:=Tag <> -1;
  if chEnaAll.Checked then
  begin
    chEditGroup.Checked:=Tag and 1 = 0;
    chSort.Checked:=Tag and 2 = 0;
    chFilter.Checked:=Tag and 4 = 0;
    chColumn.Checked:=Tag and 8 = 0;
    chProps.Checked:=Tag and 16 = 0;
    chClose.Checked:=Tag and 128 = 0;

    chAdd.Checked:=Tag and 1024 = 0;
    chDuplic.Checked:=Tag and 256 = 0;
    chEdit.Checked:=Tag and 2048 = 0;
    chDelete.Checked:=Tag and 4096 = 0;
    chSaveAdd.Checked:=Tag and 512 = 0;
    chAutoEdit.Checked:=Tag and 8192 = 0;
  end;
  chEnaAllClick(nil);
  chEditGroupClick(nil);
  // load fields
  lbFields.Clear;
  if Flds <> nil then
    for i:=0 to Flds.Count - 1 do
      lbFields.Items.Add(Flds[i].FieldName);
  LoadCol(false);
  RefSelCol;

  // load FieldsAs...
  AssignCheckItems(lbLink, Gr.FieldsAsLink);
  AssignCheckItems(lbBool, Gr.FieldsAsBoolean);
  AssignCheckItems(lbDataBar, Gr.FieldsAsDataBar);
  AssignCheckItems(lbStatusBar, Gr.FieldsAsStatusBar);
  AssignCheckItems(lbPick, FAsPick);
  LoadDrawPick;
  AssignCheckItems(lbColor, FAsColor);
  AssignCheckItems(lbDate, FAsDate);
  AssignCheckItems(lbTime, FAsTime);
  AssignCheckItems(lbHTMLText, FAsHTMLText);
  AssignCheckItems(lbRichText, FAsRichText);
  AssignCheckItems(lbGraphics, FAsGraphics);
  AssignCheckItems(lbFixedWidth, FAsFixedWidth);
  AssignCheckItems(lbTitleImg, Gr.TitleImages);

  // load DataImg
  cbDataImg.Items.Assign(lbFields.Items);

  // load groups
  LoadGroups(false);
  chGrouppingOn.Checked:=FOptionsEx2.Groups.Active;
  chMergedCell.Checked:=FOptionsEx2.Groups.ShowMergedCell;
  chCanExpand.Checked:=FOptionsEx2.Groups.CanExpand;

  // load TitleButtons
  AssignCheckItems(lbTitleButtons, FTitleButtons);

  // load TitleHints
  lbHints.Items.Assign(lbFields.Items);
  for i:=0 to lbHints.Items.Count - 1 do
  begin
    p:=FTitleHints.IndexOfName(lbHints.Items[i]);
    if p < 0 then
      p:=FTitleHints.IndexOfName(lbHints.Items[i] + MergedCellSuffix);
    if p < 0 then
      for idx:=1 to 5 do
      begin
        p:=FTitleHints.IndexOfName(lbHints.Items[i] + Format(ButtonSuffix, [idx]));
        if p >= 0 then
          Break;
      end;
    lbHints.Checked[i]:=p >= 0;
  end;

  // load FilterButtons
  AssignCheckItems(lbFilterFields, FFilterBtn);
  chFilterFunnelBtn.Checked:=FOptionsEx2.Filters.FunnelBtn;
  chFilterTextBar.Checked:=FOptionsEx2.Filters.TextBar;
  chFilterPanel.Checked:=FOptionsEx2.Filters.FilterPanel;
  eFilterPanelButtons.Text:=FOptionsEx2.Filters.FilterPanelButtonList;
  eFilterPanelBtn1Hint.Text:=FTitleHints.Values[FilterPanelFieldHint + Format(ButtonSuffix, [1])];
  eFilterPanelBtn2Hint.Text:=FTitleHints.Values[FilterPanelFieldHint + Format(ButtonSuffix, [2])];
  eFilterPanelBtn3Hint.Text:=FTitleHints.Values[FilterPanelFieldHint + Format(ButtonSuffix, [3])];

  // load FooterRow
  AssignCheckItems(lbFooterFields, Gr.FooterRow.FieldFooterDefs);
  chFooterOn.Checked:=Gr.FooterRow.FooterVisible;
end;

procedure TrDBGrid_DTEditForm.SetCheckedItems(LB: TrCheckListBox; L: TStrings);
var
  i: Integer;
begin
  L.Clear;
  for i:=0 to LB.Items.Count - 1 do
    if LB.Checked[i] then
      L.Add(LB.Items[i]);
  Gr.Invalidate;
end;

procedure TrDBGrid_DTEditForm.SetProps;
begin
  // set action control
  if not chEnaAll.Checked then
    Tag:=-1
  else
  begin
    Tag:=0;
    if not chEditGroup.Checked then
      Tag:=Tag or 1;
    if not chSort.Checked then
      Tag:=Tag or 2;
    if not chFilter.Checked then
      Tag:=Tag or 4;
    if not chColumn.Checked then
      Tag:=Tag or 8;
    if not chProps.Checked then
      Tag:=Tag or 16;
    if not chClose.Checked then
      Tag:=Tag or 128;

    if not chAdd.Checked then
      Tag:=Tag or 1024;
    if not chDuplic.Checked then
      Tag:=Tag or 256;
    if not chEdit.Checked then
      Tag:=Tag or 2048;
    if not chDelete.Checked then
      Tag:=Tag or 4096;
    if not chSaveAdd.Checked then
      Tag:=Tag or 512;
    if not chAutoEdit.Checked then
      Tag:=Tag or 8192;
  end;

  SetCheckedItems(lbPick, FAsPick);
  SetCheckedItems(lbColor, FAsColor);
  SetCheckedItems(lbDate, FAsDate);
  SetCheckedItems(lbHTMLText, FAsHTMLText);
  SetCheckedItems(lbRichText, FAsRichText);
  SetCheckedItems(lbFixedWidth, FAsFixedWidth);
end;

procedure TrDBGrid_DTEditForm.pcChange(Sender: TObject);
begin
  if pc.ActivePage = tsGroup then
    LoadGroups(true);
end;

// simple checklist
procedure TrDBGrid_DTEditForm.lbGraphicsClickCheck(Sender: TObject);
begin
  SetCheckedItems(lbGraphics, FAsGraphics);
end;

procedure TrDBGrid_DTEditForm.lbFilterFieldsClickCheck(Sender: TObject);
begin
  SetCheckedItems(lbFilterFields, FFilterBtn);
end;

// Columns proc
procedure TrDBGrid_DTEditForm.LoadCol(KeepSelected: Boolean);
var
  i, oldId, oldTop: Integer;
begin
  // load columns
  oldId:=lbCol.ItemIndex;
  oldTop:=lbCol.TopIndex;
  lbCol.Items.BeginUpdate;
  try
    lbCol.Items.Clear;
    for i:=0 to Cs.Count - 1 do
      lbCol.Items.Add(Cs[i].Title.Caption);
    for i:=0 to Cs.Count - 1 do
    begin
      lbCol.Checked[i]:=Cs[i].Visible;
      with Gr.GetFieldGroupInfo(Cs[i].Field) do
        if IsGrouped and not IsMaster then
          lbCol.ItemEnabled[i]:=Gr.IsFieldGroupMasterVisible(Cs[i].Field);
    end;
    if KeepSelected then
    begin
      lbCol.TopIndex:=oldTop;
      if (oldId >= 0) and (oldId < lbCol.Items.Count) then
        lbCol.ItemIndex:=oldId;
      RefSelCol;
    end;
  finally
    lbCol.Items.EndUpdate;
  end;
  lbCol.Invalidate;
end;

procedure TrDBGrid_DTEditForm.AddCol(Fld: TField);
var
  C: TColumn;
  oldItemIndex: Integer;
begin
  oldItemIndex:=lbCol.ItemIndex;
  C:=Cs.Add;
  C.FieldName:=Fld.FieldName;
  C.Title.Caption:=ReplaceStr(eSep.Text, ' ', Fld.DisplayLabel, true, false);
  C.Title.Alignment:=C.Alignment;
  C.ReadOnly:=Fld.ReadOnly;
  C.Visible:=Fld.Visible;
  try
    if Assigned(Fld) then
      C.Width:=Fld.DisplayWidth * 4;
    if C.Width < 50 then
      C.Width:=50;
    if C.Width > 200 then
      C.Width:=200;
  except
  end;
  if (oldItemIndex < 0) or (oldItemIndex > Cs.Count - 1) then
    oldItemIndex:=Cs.Count - 1
  else
    Inc(oldItemIndex);
  C.Index:=oldItemIndex;
  LoadCol(false);
  lbCol.ItemIndex:=oldItemIndex;
  RefSelCol;
end;

procedure TrDBGrid_DTEditForm.btMoveClick(Sender: TObject);
var
  i: Integer;
begin
  for i:=0 to lbFields.Items.Count - 1 do
    if lbFields.Selected[i] then
      AddCol(Flds[i]);
  // LoadProps;
end;

procedure TrDBGrid_DTEditForm.btMoveAllClick(Sender: TObject);
var
  i: Integer;
begin
  if DlgQ('Add all columns?') <> mrYes then
    Exit;
  for i:=0 to lbFields.Items.Count - 1 do
    lbFields.Selected[i]:=true;
  btMove.Click;
end;

procedure TrDBGrid_DTEditForm.lbColClick(Sender: TObject);
begin
  RefSelCol;
end;

procedure TrDBGrid_DTEditForm.eTitleChange(Sender: TObject);
begin
  if not eTitle.Focused then
    Exit;
  lbCol.Items[lbCol.ItemIndex]:=eTitle.Text;
  Cs[lbCol.ItemIndex].Title.Caption:=eTitle.Text;
end;

procedure TrDBGrid_DTEditForm.chReadOnlyClick(Sender: TObject);
begin
  if not chReadOnly.Focused then
    Exit;
  Cs[lbCol.ItemIndex].ReadOnly:=chReadOnly.Checked;
end;

procedure TrDBGrid_DTEditForm.eTitleEnter(Sender: TObject);
begin
  btNext.Default:=true;
end;

procedure TrDBGrid_DTEditForm.eTitleExit(Sender: TObject);
begin
  btNext.Default:=false;
end;

procedure TrDBGrid_DTEditForm.btNextClick(Sender: TObject);
begin
  if lbCol.ItemIndex < lbCol.Items.Count - 1 then
    lbCol.ItemIndex:=lbCol.ItemIndex + 1;
  lbColClick(nil);
end;

procedure TrDBGrid_DTEditForm.btUpClick(Sender: TObject);
begin
  MoveICheckBox(lbCol, lbCol.ItemIndex, lbCol.ItemIndex - 1);
end;

procedure TrDBGrid_DTEditForm.btDownClick(Sender: TObject);
begin
  MoveICheckBox(lbCol, lbCol.ItemIndex, lbCol.ItemIndex + 1);
end;

procedure TrDBGrid_DTEditForm.btCollapseClick(Sender: TObject);
var
  F: TField;
begin
  if lbCol.ItemIndex < 0 then
    Exit;
  if not lbCol.SelectedItemChecked then
    Exit;

  F:=Cs[lbCol.ItemIndex].Field;
  if Sender = btCollapse then
    Gr.CollapseGroup(F)
  else
    Gr.ExpandGroup(F);
  LoadCol(true);
end;

procedure TrDBGrid_DTEditForm.MoveICheckBox(List: TCheckListBox; old, new: Integer);
begin
  if not MoveCheckListBox(List, old, new) then
    Exit;
  Cs[old].Index:=new;
  RefSelCol;
end;

procedure TrDBGrid_DTEditForm.MoveIListBox(List: TListBox; old, new: Integer);
begin
  if not MoveListBox(List, old, new) then
    Exit;
end;

procedure TrDBGrid_DTEditForm.CheckI(act: Integer);
begin
  if not lbCol.ItemEnabled[act] then
    Exit;
  Cs[act].Visible:=lbCol.Checked[act];
  if Gr.GetFieldGroupInfo(Cs[act].Field).IsMaster then
  begin
    if (not Cs[act].Visible) then
      Gr.CollapseGroup(Cs[act].Field);
    LoadCol(true);
  end;
end;

procedure TrDBGrid_DTEditForm.RefSelCol;
begin
  gbColBottom.Enabled:=(lbCol.ItemIndex >= 0) and (lbCol.ItemIndex < Cs.Count) and (lbCol.ItemIndex < lbCol.Count);
  if gbColBottom.Enabled then
  begin
    lblFName.Caption:=Cs[lbCol.ItemIndex].FieldName;
    eTitle.Text:=lbCol.Items[lbCol.ItemIndex];
    chReadOnly.Checked:=Cs[lbCol.ItemIndex].ReadOnly;
    chReadOnly.Enabled:=true;
    lblFontReset.Enabled:=(cvFont in Cs[lbCol.ItemIndex].AssignedValues) or (cvTitleFont in Cs[lbCol.ItemIndex].AssignedValues);
  end
  else
  begin
    lblFName.Caption:='';
    eTitle.Text:='';
    // lblFontReset.Enabled:=false;
  end;
  btUp.Enabled:=gbColBottom.Enabled;
  btDown.Enabled:=gbColBottom.Enabled;
  btCollapse.Enabled:=gbColBottom.Enabled and Gr.GetFieldGroupInfo(Cs[lbCol.ItemIndex].Field).IsMaster;
  btExpand.Enabled:=gbColBottom.Enabled and btCollapse.Enabled;
end;

procedure TrDBGrid_DTEditForm.lblAlignAnchorClick(Sender: TObject; LinkName: string);
begin
  if SameText(LinkName, 'TL') then
    Cs[lbCol.ItemIndex].Title.Alignment:=taLeftJustify;
  if SameText(LinkName, 'TC') then
    Cs[lbCol.ItemIndex].Title.Alignment:=taCenter;
  if SameText(LinkName, 'TR') then
    Cs[lbCol.ItemIndex].Title.Alignment:=taRightJustify;
  if SameText(LinkName, 'CL') then
    Cs[lbCol.ItemIndex].Alignment:=taLeftJustify;
  if SameText(LinkName, 'CC') then
    Cs[lbCol.ItemIndex].Alignment:=taCenter;
  if SameText(LinkName, 'CR') then
    Cs[lbCol.ItemIndex].Alignment:=taRightJustify;
end;

procedure TrDBGrid_DTEditForm.lblFontResetAnchorClick(Sender: TObject; LinkName: string);
begin
  if (cvFont in Cs[lbCol.ItemIndex].AssignedValues) then
    Cs[lbCol.ItemIndex].RestoreDefaults
  else
    Cs[lbCol.ItemIndex].Title.RestoreDefaults;
  RefSelCol;
  lbCol.Invalidate;
end;

procedure TrDBGrid_DTEditForm.lblFontSetAnchorClick(Sender: TObject; LinkName: string);
begin
  if SameText(LinkName, 'Title') then
  begin
    FontDlg.Font.Assign(Cs[lbCol.ItemIndex].Title.Font);
    if FontDlg.Execute then
      Cs[lbCol.ItemIndex].Title.Font.Assign(FontDlg.Font);
  end;
  if SameText(LinkName, 'Col') then
  begin
    FontDlg.Font.Assign(Cs[lbCol.ItemIndex].Font);
    if FontDlg.Execute then
      Cs[lbCol.ItemIndex].Font.Assign(FontDlg.Font);
  end;
  RefSelCol;
  lbCol.Invalidate;
end;

procedure TrDBGrid_DTEditForm.lbColDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept:=true;
  MoveICheckBox(lbCol, lbCol.ItemIndex, Y div lbCol.ItemHeight + lbCol.TopIndex);
end;

procedure TrDBGrid_DTEditForm.lbColDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  s: string;
begin
  with Control as TCheckListBox do
  begin
    Canvas.FillRect(Rect);
    if Gr.GetFieldGroupInfo(Cs[Index].Field).IsMaster then
      Canvas.Font.Style:=Canvas.Font.Style + [fsBold]
    else
      Canvas.Font.Style:=Canvas.Font.Style - [fsBold];
    Canvas.TextOut(Rect.Left + 1, Rect.Top, Items[Index]);
    s:='';
    if (Index >= 0) and (Index < Cs.Count) then
    begin
      if cvFont in Cs[Index].AssignedValues then
        s:='C';
      if cvTitleFont in Cs[Index].AssignedValues then
        s:=s + 'T';
      if s <> '' then
        Canvas.TextOut(Rect.Right - 20, Rect.Top, s);
    end;
  end;
end;

procedure TrDBGrid_DTEditForm.gbRight1RefreshAutoPosition(Sender: TObject);
begin
  lbCol.Invalidate;
end;

procedure TrDBGrid_DTEditForm.btFixedWidthClick(Sender: TObject);
begin
  if lbFixedWidth.CheckedCount = lbFixedWidth.Count then
    lbFixedWidth.CheckAll(cbUnchecked)
  else
    lbFixedWidth.CheckAll(cbChecked);
end;

procedure TrDBGrid_DTEditForm.lbColClickCheck(Sender: TObject);
begin
  CheckI(lbCol.ItemIndex);
end;

procedure TrDBGrid_DTEditForm.lbColKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_UP) and (ssCtrl in Shift) then
  begin
    MoveICheckBox(lbCol, lbCol.ItemIndex, lbCol.ItemIndex - 1);
    Key:=0;
  end;
  if (Key = VK_DOWN) and (ssCtrl in Shift) then
  begin
    MoveICheckBox(lbCol, lbCol.ItemIndex, lbCol.ItemIndex + 1);
    Key:=0;
  end;
  if (Key = VK_DELETE) then
  begin
    btDel.Click;
    Key:=0;
  end;
end;

procedure TrDBGrid_DTEditForm.btDelClick(Sender: TObject);
var
  i: Integer;
begin
  i:=lbCol.ItemIndex;
  if i = -1 then
    Exit;
  Cs.Delete(i);
  lbCol.Items.Delete(i);
  if i > lbCol.Items.Count - 1 then
    i:=lbCol.Items.Count - 1;
  lbCol.ItemIndex:=i;
  RefSelCol;
end;

procedure TrDBGrid_DTEditForm.btDelAllClick(Sender: TObject);
begin
  if DlgQ('Delete all columns?') <> mrYes then
    Exit;
  Cs.Clear;
  lbCol.Clear;
  RefSelCol;
end;

procedure TrDBGrid_DTEditForm.btDelNoFieldClick(Sender: TObject);
var
  i: Integer;
begin
  if DlgQ('Delete all orphan columns (without field)?') <> mrYes then
    Exit;
  for i:=Cs.Count - 1 downto 0 do
    if lbFields.Items.IndexOf(Cs.Items[i].FieldName) < 0 then
    begin
      Cs.Delete(i);
      lbCol.Items.Delete(i);
    end;
  RefSelCol;
end;

procedure TrDBGrid_DTEditForm.chEditGroupClick(Sender: TObject);
begin
  gbEdit.Visible:=chEditGroup.Checked;
end;

procedure TrDBGrid_DTEditForm.chEnaAllClick(Sender: TObject);
begin
  gbActions.Visible:=chEnaAll.Checked;
end;

// FieldAsPickList proc
procedure TrDBGrid_DTEditForm.lbPickClickCheck(Sender: TObject);
begin
  LoadDrawPick;
end;

procedure TrDBGrid_DTEditForm.StoreDrawPick;
var
  i: Integer;
begin
  FDrawDropDown.Clear;
  for i:=0 to lbDrawPick.Items.Count - 1 do
    if lbDrawPick.Checked[i] then
      FDrawDropDown.Add(lbDrawPick.Items[i]);
end;

procedure TrDBGrid_DTEditForm.LoadDrawPick;
var
  i: Integer;
begin
  lbDrawPick.Items.Clear;
  for i:=0 to lbPick.Items.Count - 1 do
    if lbPick.Checked[i] then
      lbDrawPick.Items.Add(lbPick.Items[i]);
  for i:=0 to lbDrawPick.Items.Count - 1 do
    lbDrawPick.Checked[i]:=FDrawDropDown.IndexOf(lbDrawPick.Items[i]) >= 0;
end;

procedure TrDBGrid_DTEditForm.lbDrawPickClickCheck(Sender: TObject);
begin
  StoreDrawPick;
end;

// FieldAsLink proc
procedure TrDBGrid_DTEditForm.lbLinkClick(Sender: TObject);
begin
  cbLinkType.Enabled:=lbLink.SelectedItemChecked;
  cbLinkType.ItemIndex:=ord(Gr.Fields_GetLinkType(lbLink.SelectedItemText)) - 1;
end;

procedure TrDBGrid_DTEditForm.lbLinkClickCheck(Sender: TObject);
var
  i: Integer;
begin
  if lbLink.SelectedItemChecked then
    i:=1
  else
    i:=0;
  Gr.Fields_SetLinkType(lbLink.SelectedItemText, TrLinkType(i));
end;

procedure TrDBGrid_DTEditForm.cbLinkTypeExit(Sender: TObject);
begin
  Gr.Fields_SetLinkType(lbLink.SelectedItemText, TrLinkType(cbLinkType.ItemIndex + 1));
end;

// FieldsAsBool proc
procedure TrDBGrid_DTEditForm.lbBoolClick(Sender: TObject);
begin
  eBoolVal.Enabled:=lbBool.SelectedItemChecked;
  eBoolVal.Text:=Gr.Fields_GetBoolValues(lbBool.SelectedItemText);
end;

procedure TrDBGrid_DTEditForm.lbBoolClickCheck(Sender: TObject);
var
  s: string;
begin
  if lbBool.SelectedItemChecked then
    s:=rDefBoolValue
  else
    s:='';
  Gr.Fields_SetBoolValues(lbBool.SelectedItemText, s);
end;

procedure TrDBGrid_DTEditForm.eBoolValExit(Sender: TObject);
begin
  Gr.Fields_SetBoolValues(lbBool.SelectedItemText, eBoolVal.Text);
end;

// FieldsAsTime
procedure TrDBGrid_DTEditForm.lbTimeClick(Sender: TObject);
begin
  eTimeStep.Enabled:=lbTime.SelectedItemChecked;
  eTimeStep.AsInteger:=StrToIntDef(FAsTime.Values[lbTime.SelectedItemText], 1);
end;

procedure TrDBGrid_DTEditForm.lbTimeClickCheck(Sender: TObject);
var
  s: string;
begin
  if lbTime.SelectedItemChecked then
    s:='5'
  else
    s:='';
  FAsTime.Values[lbTime.SelectedItemText]:=s;
end;

procedure TrDBGrid_DTEditForm.eTimeStepExit(Sender: TObject);
begin
  FAsTime.Values[lbTime.SelectedItemText]:=IntToStr(eTimeStep.AsInteger);
end;

// databar setting
procedure TrDBGrid_DTEditForm.lbDataBarClick(Sender: TObject);
var
  vmin, vmax: double;
  valType: TrDataBarText;
  CFrom, CTo: TColor;

  procedure UpdateVals;
  begin
    eDatabarMin.Value:=vmin;
    eDatabarMax.Value:=vmax;
    cbDataBarText.ItemIndex:=ord(valType);
    cbDatabarColorFrom.Selected:=CFrom;
    cbDatabarColorTo.Selected:=CTo;
  end;

begin
  gbDataBarParams.Enabled:=lbDataBar.SelectedItemChecked;
  vmin:=0;
  vmax:=0;
  valType:=dbtPercent;
  CFrom:=clNone;
  CTo:=clNone;
  if gbDataBarParams.Enabled then
  begin
    if Gr.Fields_GetDataBarSettings(lbDataBar.SelectedItemText, vmin, vmax, valType, CFrom, CTo) then
    begin
      UpdateVals;
      RefDatabarDemo;
    end
    else
    begin
      vmax:=100;
      UpdateVals;
      eDatabarMinExit(nil);
    end;
  end
  else
    UpdateVals;
  gbDatabarDemo.Visible:=gbDataBarParams.Enabled;
end;

procedure TrDBGrid_DTEditForm.lbDataBarClickCheck(Sender: TObject);
begin
  if lbDataBar.SelectedItemChecked then
    Gr.Fields_SetDataBarSettings(lbDataBar.SelectedItemText, 0, 100)
  else
    Gr.Fields_SetDataBarSettings(lbDataBar.SelectedItemText, 0, 0);
end;

procedure TrDBGrid_DTEditForm.eDatabarMinExit(Sender: TObject);
begin
  Gr.Fields_SetDataBarSettings(lbDataBar.SelectedItemText, eDatabarMin.Value, eDatabarMax.Value, TrDataBarText(cbDataBarText.ItemIndex),
    cbDatabarColorFrom.Selected, cbDatabarColorTo.Selected);
  RefDatabarDemo;
end;

procedure TrDBGrid_DTEditForm.RefDatabarDemo;
var
  CFrom, CTo: TColor;
begin
  CFrom:=cbDatabarColorFrom.Selected;
  if CFrom = clNone then
    CFrom:=clSkyBlue;
  CTo:=cbDatabarColorTo.Selected;
  if CTo = clNone then
    CTo:=clWhite;
  gbDatabarDemo.FrameColor:=CFrom;
  gbDatabarDemo.GradientColorFrom:=CFrom;
  gbDatabarDemo.GradientColorTo:=CTo;
end;

// StatusBar
procedure TrDBGrid_DTEditForm.lbStatusBarClick(Sender: TObject);
var
  vmax: Integer;
  BarType: TrStatusBarType;
  CFrom, CTo: TColor;

  procedure UpdateVals;
  begin
    eStatusSteps.AsInteger:=vmax;
    cbStatusType.ItemIndex:=ord(BarType);
    cbStatusColorAll.Selected:=CFrom;
    cbStatusColorDone.Selected:=CTo;
  end;

begin
  gbStatusBarParams.Enabled:=lbStatusBar.SelectedItemChecked;
  vmax:=0;
  BarType:=sbtProgressBar;
  CFrom:=clNone;
  CTo:=clNone;
  if gbStatusBarParams.Enabled then
  begin
    if Gr.Fields_GetStatusBarSettings(lbStatusBar.SelectedItemText, vmax, BarType, CFrom, CTo) then
    begin
      UpdateVals;
    end
    else
    begin
      vmax:=5;
      UpdateVals;
      eStatusStepsExit(nil);
    end;
  end
  else
  begin
    UpdateVals;
    cbStatusType.ItemIndex:=-1;
  end;
end;

procedure TrDBGrid_DTEditForm.lbStatusBarClickCheck(Sender: TObject);
begin
  if lbStatusBar.SelectedItemChecked then
    Gr.Fields_SetStatusBarSettings(lbStatusBar.SelectedItemText, 5)
  else
    Gr.Fields_SetStatusBarSettings(lbStatusBar.SelectedItemText, 0);
end;

procedure TrDBGrid_DTEditForm.eStatusStepsExit(Sender: TObject);
begin
  Gr.Fields_SetStatusBarSettings(lbStatusBar.SelectedItemText, eStatusSteps.AsInteger, TrStatusBarType(cbStatusType.ItemIndex), cbStatusColorAll.Selected,
    cbStatusColorDone.Selected);
end;

// TitleImage proc
procedure TrDBGrid_DTEditForm.lbTitleImgClick(Sender: TObject);
begin
  eTitleImg.Enabled:=lbTitleImg.SelectedItemChecked;
  UpDownTitleImg.Enabled:=eTitleImg.Enabled;
  eTitleImg.AsInteger:=Gr.Title_GetImageIndex(lbTitleImg.SelectedItemText);
end;

procedure TrDBGrid_DTEditForm.lbTitleImgClickCheck(Sender: TObject);
var
  i: Integer;
begin
  if lbTitleImg.SelectedItemChecked then
    i:=0
  else
    i:=-1;
  Gr.Title_SetImageIndex(lbTitleImg.SelectedItemText, i);
end;

procedure TrDBGrid_DTEditForm.eTitleImgExit(Sender: TObject);
begin
  Gr.Title_SetImageIndex(lbTitleImg.SelectedItemText, eTitleImg.AsInteger);
end;

procedure TrDBGrid_DTEditForm.eTitleImgChange(Sender: TObject);
begin
  TitleImg.Picture.Bitmap:=nil;
  if Assigned(Gr) and Assigned(Gr.TitleImageList) and (eTitleImg.AsInteger >= 0) and (eTitleImg.AsInteger < Gr.TitleImageList.Count) then
  begin
    Gr.TitleImageList.GetBitmap(eTitleImg.AsInteger, TitleImg.Picture.Bitmap);
  end;
end;

// DataImage proc
procedure TrDBGrid_DTEditForm.SetIniSection;
var
  al: string;
begin
  al:=cbDataImgAlign.Text;
  if lbDataImg.Items.Count = 0 then
    al:='';
  Gr.DataImages_SetSettings(cbDataImg.Text, lbDataImg.Items, al);
end;

procedure TrDBGrid_DTEditForm.cbDataImgAlignChange(Sender: TObject);
begin
  SetIniSection;
end;

procedure TrDBGrid_DTEditForm.cbDataImgChange(Sender: TObject);
var
  al: string;
begin
  lbDataImg.Items.Clear;
  Gr.DataImages_GetSettings(cbDataImg.Text, lbDataImg.Items, al);
  cbDataImgAlign.Text:=al;
  cbDataImgAlign.Enabled:=cbDataImg.Text <> '';
  lbDataImgClick(self);
end;

procedure TrDBGrid_DTEditForm.lbDataImgClick(Sender: TObject);
var
  s: string;
begin
  eDataImgVal.Text:='';
  eDataImgText.Text:='';
  eDataImgIdx.AsInteger:=-1;
  grDataImgBottom.Enabled:=lbDataImg.ItemIndex >= 0;
  if grDataImgBottom.Enabled then
  begin
    eDataImgVal.Text:=lbDataImg.Items.Names[lbDataImg.ItemIndex];
    s:=lbDataImg.Items.Values[eDataImgVal.Text];
    try
      StrToInt(s);
      eDataImgIdx.Text:=s;
    except
      eDataImgText.Text:=s;
      eDataImgIdx.Enabled:=false;
      UpDownDataImg.Enabled:=false;
    end;
  end;
end;

procedure TrDBGrid_DTEditForm.lbDataImgDragOver(Sender, Source: TObject; X, Y: Integer; State: TDragState; var Accept: Boolean);
begin
  Accept:=true;
  MoveIListBox(lbDataImg, lbDataImg.ItemIndex, Y div lbDataImg.ItemHeight + lbDataImg.TopIndex);
  SetIniSection;
end;

procedure TrDBGrid_DTEditForm.lbDataImgKeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_UP) and (ssCtrl in Shift) then
  begin
    MoveIListBox(lbDataImg, lbDataImg.ItemIndex, lbDataImg.ItemIndex - 1);
    Key:=0;
    SetIniSection;
  end;
  if (Key = VK_DOWN) and (ssCtrl in Shift) then
  begin
    MoveIListBox(lbDataImg, lbDataImg.ItemIndex, lbDataImg.ItemIndex + 1);
    Key:=0;
    SetIniSection;
  end;
end;

procedure TrDBGrid_DTEditForm.eDataImgValExit(Sender: TObject);
var
  s: string;
begin
  if lbDataImg.ItemIndex < 0 then
    Exit;
  if eDataImgVal.Text = '' then
  begin
    eDataImgVal.SetFocus;
    Exit;
  end;
  s:=eDataImgText.Text;
  eDataImgIdx.Enabled:=s = '';
  UpDownDataImg.Enabled:=s = '';
  if s = '' then
    s:=eDataImgIdx.Text;
  lbDataImg.Items[lbDataImg.ItemIndex]:=eDataImgVal.Text + '=' + s;
  lbDataImgClick(self);
  SetIniSection;
end;

procedure TrDBGrid_DTEditForm.btDDelClick(Sender: TObject);
begin
  if lbDataImg.ItemIndex < 0 then
    Exit;
  lbDataImg.Items.Delete(lbDataImg.ItemIndex);
  lbDataImgClick(self);
  SetIniSection;
end;

procedure TrDBGrid_DTEditForm.btDAddClick(Sender: TObject);
begin
  lbDataImg.Items.Add('*=0');
  lbDataImg.ItemIndex:=lbDataImg.Items.Count - 1;
  lbDataImgClick(self);
  SetIniSection;
end;

procedure TrDBGrid_DTEditForm.eDataImgIdxChange(Sender: TObject);
begin
  DataImg.Picture.Bitmap:=nil;
  if Assigned(Gr) and Assigned(Gr.DataImageList) and (eDataImgIdx.AsInteger >= 0) and (eDataImgIdx.AsInteger < Gr.DataImageList.Count) then
  begin
    Gr.DataImageList.GetBitmap(eDataImgIdx.AsInteger, DataImg.Picture.Bitmap);
  end;
end;

procedure TrDBGrid_DTEditForm.cbDataImgDrawItem(Control: TWinControl; Index: Integer; Rect: TRect; State: TOwnerDrawState);
var
  al: string;
begin
  with Control as TComboBox do
  begin
    Canvas.FillRect(Rect);
    if Gr.DataImages_GetSettings(Items[Index], nil, al) > 0 then
      Canvas.Font.Style:=Canvas.Font.Style + [fsBold];
    Canvas.TextOut(Rect.Left + 1, Rect.Top + 1, Items[Index]);
  end;
end;

procedure TrDBGrid_DTEditForm.UpDownTitleImgChangingEx(Sender: TObject; var AllowChange: Boolean; NewValue: Smallint; Direction: TUpDownDirection);
begin
  if Direction = updUp then
    eTitleImg.AsInteger:=eTitleImg.AsInteger + 1;
  if Direction = updDown then
    eTitleImg.AsInteger:=eTitleImg.AsInteger - 1;
  eTitleImg.SetFocus;
end;

procedure TrDBGrid_DTEditForm.UpDownDataImgChangingEx(Sender: TObject; var AllowChange: Boolean; NewValue: Smallint; Direction: TUpDownDirection);
begin
  if Direction = updUp then
    eDataImgIdx.AsInteger:=eDataImgIdx.AsInteger + 1;
  if Direction = updDown then
    eDataImgIdx.AsInteger:=eDataImgIdx.AsInteger - 1;
  eDataImgIdx.SetFocus;
end;

// TitleButtons
procedure TrDBGrid_DTEditForm.lbTitleButtonsClick(Sender: TObject);
var
  fn: string;
begin
  gbTitleBtnOpt.Enabled:=lbTitleButtons.SelectedItemChecked;
  if eTitleButtons.Enabled then
  begin
    fn:=lbTitleButtons.Items[lbTitleButtons.ItemIndex];
    eTitleButtons.Text:=FTitleButtons.Values[fn];
    eTitleBtn1Hint.Text:=FTitleHints.Values[fn + Format(ButtonSuffix, [1])];
    eTitleBtn2Hint.Text:=FTitleHints.Values[fn + Format(ButtonSuffix, [2])];
    eTitleBtn3Hint.Text:=FTitleHints.Values[fn + Format(ButtonSuffix, [3])];
  end
  else
  begin
    eTitleButtons.Text:='';
    eTitleBtn1Hint.Text:='';
    eTitleBtn2Hint.Text:='';
    eTitleBtn3Hint.Text:='';
  end;
end;

procedure TrDBGrid_DTEditForm.lbTitleButtonsClickCheck(Sender: TObject);
var
  fn: string;
begin
  fn:=lbTitleButtons.SelectedItemText;
  if lbTitleButtons.SelectedItemChecked then
    FTitleButtons.Values[fn]:='0'
  else
  begin
    FTitleButtons.Values[fn]:='';
    FTitleHints.Values[fn + Format(ButtonSuffix, [1])]:='';
    FTitleHints.Values[fn + Format(ButtonSuffix, [2])]:='';
    FTitleHints.Values[fn + Format(ButtonSuffix, [3])]:='';
  end;
  if Assigned(Gr) then
    Gr.Invalidate;
end;

procedure TrDBGrid_DTEditForm.eTitleButtonsChange(Sender: TObject);
var
  i, idx: Integer;
  s, p: string;
begin
  for i:=0 to gbTitleBtnImages.ControlCount - 1 do
    TImage(gbTitleBtnImages.Controls[i]).Picture.Bitmap:=nil;
  if Assigned(Gr) and Assigned(Gr.TitleImageList) then
  begin
    s:=eTitleButtons.Text;
    i:=0;
    repeat
      p:=Trim(rtool.RemoveStrPart(s, ','));
      idx:=StrToIntDef(p, -1);
      if (idx >= 0) and (idx < Gr.TitleImageList.Count) then
        Gr.TitleImageList.GetBitmap(idx, TImage(gbTitleBtnImages.Controls[i]).Picture.Bitmap);
      Inc(i);
    until (s = '') or (i >= 3);
  end;
end;

procedure TrDBGrid_DTEditForm.eTitleButtonsExit(Sender: TObject);
begin
  FTitleButtons.Values[lbTitleButtons.SelectedItemText]:=eTitleButtons.Text;
end;

// Filters
procedure TrDBGrid_DTEditForm.chFilterFunnelBtnClick(Sender: TObject);
begin
  FOptionsEx2.Filters.FunnelBtn:=chFilterFunnelBtn.Checked;
end;

procedure TrDBGrid_DTEditForm.chFilterPanelClick(Sender: TObject);
begin
  FOptionsEx2.Filters.FilterPanel:=chFilterPanel.Checked;
  gbFilterPanel.Enabled:=chFilterPanel.Checked;
end;

procedure TrDBGrid_DTEditForm.chFilterTextBarClick(Sender: TObject);
begin
  FOptionsEx2.Filters.TextBar:=chFilterTextBar.Checked;
end;

procedure TrDBGrid_DTEditForm.eFilterPanelButtonsChange(Sender: TObject);
var
  i, idx: Integer;
  s, p: string;
begin
  for i:=0 to gbFilterPanelBtnImages.ControlCount - 1 do
    TImage(gbFilterPanelBtnImages.Controls[i]).Picture.Bitmap:=nil;

  if Assigned(Gr) and Assigned(Gr.TitleImageList) then
  begin
    s:=eFilterPanelButtons.Text;
    i:=0;
    repeat
      p:=Trim(rtool.RemoveStrPart(s, ','));
      idx:=StrToIntDef(p, -1);
      if (idx >= 0) and (idx < Gr.TitleImageList.Count) then
        Gr.TitleImageList.GetBitmap(idx, TImage(gbFilterPanelBtnImages.Controls[i]).Picture.Bitmap);
      Inc(i);
    until (s = '') or (i >= 3);
  end;
end;

procedure TrDBGrid_DTEditForm.eFilterPanelButtonsExit(Sender: TObject);
begin
  FOptionsEx2.Filters.FilterPanelButtonList:=eFilterPanelButtons.Text;
end;

// Hints def
procedure TrDBGrid_DTEditForm.lbHintsClick(Sender: TObject);
var
  fn: string;
begin
  gbTitleHintOpt.Enabled:=lbHints.SelectedItemChecked;
  if gbTitleHintOpt.Enabled then
  begin
    fn:=lbHints.SelectedItemText;
    eHint.Text:=FTitleHints.Values[fn];
    eMergedCellHint.Text:=FTitleHints.Values[fn + MergedCellSuffix];
  end
  else
  begin
    eHint.Text:='';
    eMergedCellHint.Text:='';
  end;
end;

procedure TrDBGrid_DTEditForm.lbHintsClickCheck(Sender: TObject);
var
  fn: string;
begin
  fn:=lbHints.SelectedItemText;
  if not lbHints.SelectedItemChecked then
  begin
    FTitleHints.Values[fn]:='';
    FTitleHints.Values[fn + MergedCellSuffix]:='';
  end
  else
  begin
    FTitleHints.Values[fn]:=fn;
  end;
end;

procedure TrDBGrid_DTEditForm.eHintExit(Sender: TObject);
begin
  FTitleHints.Values[lbHints.SelectedItemText]:=eHint.Text;
end;

procedure TrDBGrid_DTEditForm.eMergedCellHintExit(Sender: TObject);
begin
  FTitleHints.Values[lbHints.SelectedItemText + MergedCellSuffix]:=eMergedCellHint.Text;
end;

procedure TrDBGrid_DTEditForm.eTitleBtn1HintExit(Sender: TObject);
begin
  FTitleHints.Values[lbTitleButtons.SelectedItemText + Format(ButtonSuffix, [1])]:=eTitleBtn1Hint.Text;
end;

procedure TrDBGrid_DTEditForm.eTitleBtn2HintExit(Sender: TObject);
begin
  FTitleHints.Values[lbTitleButtons.SelectedItemText + Format(ButtonSuffix, [2])]:=eTitleBtn2Hint.Text;
end;

procedure TrDBGrid_DTEditForm.eTitleBtn3HintExit(Sender: TObject);
begin
  FTitleHints.Values[lbTitleButtons.SelectedItemText + Format(ButtonSuffix, [3])]:=eTitleBtn3Hint.Text;
end;

procedure TrDBGrid_DTEditForm.eFilterPanelBtn1HintExit(Sender: TObject);
begin
  FTitleHints.Values[FilterPanelFieldHint + Format(ButtonSuffix, [1])]:=self.eFilterPanelBtn1Hint.Text;
end;

procedure TrDBGrid_DTEditForm.eFilterPanelBtn2HintExit(Sender: TObject);
begin
  FTitleHints.Values[FilterPanelFieldHint + Format(ButtonSuffix, [2])]:=self.eFilterPanelBtn2Hint.Text;
end;

procedure TrDBGrid_DTEditForm.eFilterPanelBtn3HintExit(Sender: TObject);
begin
  FTitleHints.Values[FilterPanelFieldHint + Format(ButtonSuffix, [3])]:=self.eFilterPanelBtn3Hint.Text;
end;

// GroupFields proc
procedure TrDBGrid_DTEditForm.LoadGroups(KeepSelected: Boolean);
var
  i: Integer;
begin
  i:=lbGroups.ItemIndex;
  Gr.Fields_GetGroupList(lbGroups.Items);
  lbGroups.ItemIndex:=-1;
  if KeepSelected and (i >= 0) and (i < lbGroups.Items.Count) then
    lbGroups.ItemIndex:=i;
  lbGroupsClick(nil);
end;

function TrDBGrid_DTEditForm.GetSelGroupName: string;
begin
  if lbGroups.ItemIndex >= 0 then
    Result:=lbGroups.Items[lbGroups.ItemIndex]
  else
    Result:='';
end;

procedure TrDBGrid_DTEditForm.lbGroupFieldsClickCheck(Sender: TObject);
var
  i: Integer;
begin
  // update master combo list
  if lbGroupFields.SelectedItemChecked then
  begin
    i:=cbGroupMaster.Items.Count;
    cbGroupMaster.Items.Add(lbGroupFields.Items[lbGroupFields.ItemIndex]);
  end
  else
  begin
    i:=cbGroupMaster.Items.IndexOf(lbGroupFields.Items[lbGroupFields.ItemIndex]);
    if i >= 0 then
      cbGroupMaster.Items.Delete(i);
  end;
  if (i = 0) and (cbGroupMaster.Items.Count > 0) then
    cbGroupMaster.ItemIndex:=0;
end;

procedure TrDBGrid_DTEditForm.LoadGroupFields(FieldList: TStrings);
var
  i, idx: Integer;
begin
  // load group columns list
  lbGroupFields.Items.Assign(lbCol.Items);
  lbGroupFields.CheckAll(cbUnchecked);
  cbGroupMaster.Items.Clear;
  // check list of fields in the group and master combo list
  for i:=0 to Cs.Count - 1 do
  begin
    idx:=FieldList.IndexOf(Cs[i].FieldName);
    if idx >= 0 then
    begin
      lbGroupFields.Checked[i]:=true;
      cbGroupMaster.Items.Add(lbGroupFields.Items[i]);
      if idx = 0 then
        cbGroupMaster.ItemIndex:=cbGroupMaster.Items.IndexOf(lbGroupFields.Items[i]);
    end;
  end;
end;

procedure TrDBGrid_DTEditForm.lbGroupsClick(Sender: TObject);
var
  GroupId: Integer;
  MergedCellTitle, GrCollapsedTitle, Content: string;
  FontColor, LineColor: TColor;
  Locked: Boolean;
  FieldList: TStrings;

  procedure UpdateVals;
  begin
    eGroupMergedCellTitle.Text:=MergedCellTitle;
    eGroupCollapsedTitle.Text:=GrCollapsedTitle;
    eGroupMasterMask.Text:=Content;
    cgGroupTitleColor.Selected:=FontColor;
    cgGroupLineColor.Selected:=LineColor;
    chGroupLock.Checked:=Locked;
  end;

begin
  gbGroupBottom.Enabled:=lbGroups.ItemIndex >= 0;
  gbRightGroups.Enabled:=gbGroupBottom.Enabled;
  MergedCellTitle:='';
  GrCollapsedTitle:='';
  Content:='';
  FontColor:=clNone;
  LineColor:=clNone;
  Locked:=false;
  if gbGroupBottom.Enabled then
  begin
    FieldList:=TStringList.Create;
    try
      if Gr.Fields_GetGroupSettingsEx(GetSelGroupName, GroupId, MergedCellTitle, GrCollapsedTitle, Content, FontColor, LineColor, Locked, FieldList) then
      begin
        UpdateVals;
        LoadGroupFields(FieldList);
      end;
      lbGroups.Tag:=GroupId;
    finally
      FreeAndNil(FieldList);
    end;
  end
  else
  begin
    lbGroups.Tag:=0;
    UpdateVals;
    lbGroupFields.CheckAll(cbUnchecked);
  end;
  btDelGroup.Enabled:=gbGroupBottom.Enabled;
  btGroupCollapse.Enabled:=gbGroupBottom.Enabled;
  btGroupExpand.Enabled:=gbGroupBottom.Enabled;
end;

procedure TrDBGrid_DTEditForm.btGroupUpdateClick(Sender: TObject);
var
  i: Integer;
  FieldList: TStrings;
begin
  FieldList:=TStringList.Create;
  try
    if Sender = btNone1 then
      cgGroupTitleColor.Selected:=clNone;
    if Sender = btNone2 then
      cgGroupLineColor.Selected:=clNone;
    if Sender <> btDelGroup then
    begin
      for i:=0 to Cs.Count - 1 do
        if lbGroupFields.Checked[i] then
        begin
          if cbGroupMaster.SelectedText = lbGroupFields.Items[i] then
            FieldList.Insert(0, Cs[i].FieldName)
          else
            FieldList.Add(Cs[i].FieldName);
        end;
      if FieldList.Count = 0 then
        Exit;
    end;
    Gr.Fields_SetGroupSettingsEx(lbGroups.Tag, eGroupMergedCellTitle.Text, eGroupCollapsedTitle.Text, eGroupMasterMask.Text, cgGroupTitleColor.Selected,
      cgGroupLineColor.Selected, chGroupLock.Checked, FieldList);
    LoadGroups(true);
  finally
    FreeAndNil(FieldList);
  end;
end;

procedure TrDBGrid_DTEditForm.btNewGroupClick(Sender: TObject);
var
  ns: string;
  i, id, max: Integer;
begin
  // find max used id
  max:=0;
  for i:=0 to lbGroups.Items.Count - 1 do
  begin
    id:=StrToIntDef(rtool.FindStrPart(lbGroups.Items[i], GroupHeaderSep, 1, true), -1);
    if id > max then
      max:=id;
  end;
  // generate nd add new group
  ns:=IntToStr(max + 1) + GroupHeaderSep; // + GroupHeaderSep + GroupHeaderSep;
  lbGroups.Items.Add(ns);
  lbGroups.ItemIndex:=lbGroups.Items.Count - 1;
  lbGroupsClick(nil);
end;

procedure TrDBGrid_DTEditForm.btDelGroupClick(Sender: TObject);
begin
  if lbGroups.ItemIndex >= 0 then
    eGroupCollapsedTitleExit(Sender);
end;

procedure TrDBGrid_DTEditForm.btGroupAddMaskAnchorClick(Sender: TObject; LinkName: string);
begin
  if lbGroupFields.ItemIndex >= 0 then
  begin
    eGroupMasterMask.Text:=eGroupMasterMask.Text + '<<' + Cs[lbGroupFields.ItemIndex].FieldName + '>>';
    btGroupUpdateClick(nil);
  end;
end;

procedure TrDBGrid_DTEditForm.btGroupCollapseClick(Sender: TObject);
var
  id: Integer;
begin
  btGroupUpdateAll.Click;
  id:=StrToIntDef(rtool.FindStrPart(GetSelGroupName, GroupHeaderSep, 1, true), -1);
  if Sender = btGroupCollapse then
    Gr.CollapseGroup(id)
  else
    Gr.ExpandGroup(id);
  LoadCol(true);
end;

procedure TrDBGrid_DTEditForm.btGroupUpdateAllClick(Sender: TObject);
begin
  if btGroupUpdate.Enabled then
    btGroupUpdate.Click;
  Gr.FixedGroupedCol(chGrouppingOn.Checked and (lbGroups.Items.Count > 0));
  LoadCol(false);
  lbGroupsClick(nil);
end;

procedure TrDBGrid_DTEditForm.eGroupCollapsedTitleEnter(Sender: TObject);
begin
  btGroupUpdateAll.Default:=true;
end;

procedure TrDBGrid_DTEditForm.eGroupCollapsedTitleExit(Sender: TObject);
begin
  btGroupUpdateAll.Default:=false;
  btGroupUpdateClick(Sender);
end;

procedure TrDBGrid_DTEditForm.chCanExpandClick(Sender: TObject);
begin
  FOptionsEx2.Groups.CanExpand:=self.chCanExpand.Checked;
end;

procedure TrDBGrid_DTEditForm.chGrouppingOnClick(Sender: TObject);
begin
  if not chGrouppingOn.Checked then
    FOptionsEx2.Groups.Active:=false;
  btGroupUpdateAll.Click;
end;

procedure TrDBGrid_DTEditForm.chMergedCellClick(Sender: TObject);
begin
  FOptionsEx2.Groups.ShowMergedCell:=self.chMergedCell.Checked;
end;

// Footer
procedure TrDBGrid_DTEditForm.lbFooterFieldsClick(Sender: TObject);
var
  CMask: string;
  Align: TAlignmentDefault;
  FStyleDef: TFontStylesDefault;
  FSize: Integer;
  FColor: TColor;
begin
  isFooterUpdating:=true;
  try
    CMask:='';
    FStyleDef:=[];
    Align:=tadDefault;
    FColor:=clNone;
    FSize:=0;
    gbFooterRight.Enabled:=lbFooterFields.SelectedItemChecked;
    if gbFooterRight.Enabled then
      Gr.FooterRow_GetSettings(lbFooterFields.SelectedItemText, CMask, Align, FStyleDef, FColor, FSize);
    eFooterMask.Text:=CMask;
    gbAlignment.ItemIndex:=ord(Align);
    chNormal.Checked:=fsdNormal in FStyleDef;
    chBold.Checked:=fsdBold in FStyleDef;
    chItalic.Checked:=fsdItalic in FStyleDef;
    chUnderline.Checked:=fsdUnderline in FStyleDef;
    cbColor.Selected:=FColor;
    eFontSize.AsInteger:=FSize;
  finally
    isFooterUpdating:=false;
  end;
end;

procedure TrDBGrid_DTEditForm.lbFooterFieldsClickCheck(Sender: TObject);
begin
  if lbFooterFields.SelectedItemChecked then
    Gr.FooterRow_SetSettings(lbFooterFields.SelectedItemText, cbFooterTags.Items[0])
  else
    Gr.FooterRow_SetSettings(lbFooterFields.SelectedItemText, '');
end;

procedure TrDBGrid_DTEditForm.btAddFooterTagClick(Sender: TObject);
begin
  eFooterMask.Text:=eFooterMask.Text + self.cbFooterTags.Text;
  chNormalClick(nil);
end;

procedure TrDBGrid_DTEditForm.UpdateFooterSetting;
var
  FS: TFontStylesDefault;
begin
  if isFooterUpdating then
    Exit;
  FS:=[];
  if chNormal.Checked then
    Include(FS, fsdNormal);
  if chBold.Checked then
    Include(FS, fsdBold);
  if chItalic.Checked then
    Include(FS, fsdItalic);
  if chUnderline.Checked then
    Include(FS, fsdUnderline);
  Gr.FooterRow_SetSettings(lbFooterFields.SelectedItemText, eFooterMask.Text, TAlignmentDefault(gbAlignment.ItemIndex), FS, cbColor.Selected,
    eFontSize.AsInteger);
end;

procedure TrDBGrid_DTEditForm.chFooterOnClick(Sender: TObject);
begin
  Gr.FooterRow.FooterVisible:=self.chFooterOn.Checked;
end;

procedure TrDBGrid_DTEditForm.chNormalClick(Sender: TObject);
begin
  UpdateFooterSetting;
end;

end.
